﻿/*
 * FormNoteProperty.cs
 * Copyright (c) 2009 kbinani
 *
 * This file is part of Boare.Cadencii.
 *
 * Boare.Cadencii is free software; you can redistribute it and/or
 * modify it under the terms of the GPLv3 License.
 *
 * Boare.Cadencii is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
using System;
using System.Collections.Generic;
using System.Windows.Forms;

using Boare.Lib.Vsq;
using Boare.Lib.AppUtil;

namespace Boare.Cadencii {

    public partial class FormNoteProperty : Form {
        //public event CommandExecuteRequiredEventHandler CommandExecuteRequired;
        //private List<VsqEventItemProxy> m_items;
        //private int m_track;

        public FormNoteProperty() {
            InitializeComponent();
            //m_items = new List<VsqEventItemProxy>();
#if DEBUG
           // propertyGrid.SelectedObject = new VsqEventItemProxy( new VsqEvent() );
#endif
            ApplyLanguage();
            Misc.ApplyFontRecurse( this, AppManager.EditorConfig.BaseFont );
        }

        /*public void UpdateValue( int track ) {
            m_track = track;
            m_items.Clear();
            foreach ( SelectedEventEntry item in AppManager.SelectedEvent.GetEnumerator() ) {
                if ( item.Track == track ) {
                    m_items.Add( new VsqEventItemProxy( item.Original ) );
                }
            }
            object[] objs = new object[m_items.Count];
            for ( int i = 0; i < m_items.Count; i++ ) {
                objs[i] = m_items[i];
            }
            propertyGrid.SelectedObjects = objs;

            if ( m_items.Count <= 0 ) {
                this.Opacity = AppManager.EditorConfig.PropertyWindowMinimumOpacity;
            } else {
                this.Opacity = 1.0;
            }
        }*/

        /*public void Clear() {
            m_items.Clear();
            propertyGrid.SelectedObject = null;
            this.Opacity = AppManager.EditorConfig.PropertyWindowMinimumOpacity;
        }*/

        public void ApplyLanguage() {
            this.Text = _( "Note Property" );
        }

        private static string _( string id ) {
            return Messaging.GetMessage( id );
        }

        /*public void RemoveItem( int internal_id ) {
            for ( int i = 0; i < m_items.Count; i++ ) {
                if ( m_items[i].Original.InternalID == internal_id ) {
                    m_items.RemoveAt( i );
                    break;
                }
            }
            object[] objs = new object[m_items.Count];
            for ( int i = 0; i < objs.Length; i++ ) {
                objs[i] = m_items[i];
            }
            propertyGrid.SelectedObjects = objs;
            if ( m_items.Count <= 0 ) {
                this.Opacity = AppManager.EditorConfig.PropertyWindowMinimumOpacity;
            }
        }

        public void AppendItem( int track, VsqEvent item ) {
            if ( track != m_track ) {
                m_items.Clear();
                propertyGrid.SelectedObject = null;
            }
            this.Opacity = 1.0;
            m_track = track;
            bool found = false;
            for ( int i = 0; i < m_items.Count; i++ ) {
                if ( item.InternalID == m_items[i].Original.InternalID ) {
                    found = true;
                    break;
                }
            }
            if ( !found ) {
                VsqEventItemProxy proxy = new VsqEventItemProxy( item );
                m_items.Add( proxy );
                object[] objs = new object[m_items.Count];
                for ( int i = 0; i < objs.Length; i++ ) {
                    objs[i] = m_items[i];
                }
                propertyGrid.SelectedObjects = objs;
            }
        }*/

        /*private void propertyGrid_PropertyValueChanged( object s, PropertyValueChangedEventArgs e ) {
            string name = e.ChangedItem.PropertyDescriptor.Name;
            object old_value = e.OldValue;
            int len = propertyGrid.SelectedObjects.Length;
            VsqEvent[] items = new VsqEvent[len];
            for ( int i = 0; i < len; i++ ) {
                VsqEventItemProxy proxy = (VsqEventItemProxy)propertyGrid.SelectedObjects[i];

                items[i] = proxy.GetItemDifference();

                m_items[i].Original.Clock = proxy.Clock;
                m_items[i].Original.ID.DEMaccent = proxy.Accent;
                m_items[i].Original.ID.DEMdecGainRate = proxy.Decay;
                m_items[i].Original.ID.Dynamics = proxy.Velocity;
                m_items[i].Original.ID.Length = proxy.Length;
                m_items[i].Original.ID.LyricHandle.L0.setPhoneticSymbol( proxy.PhoneticSymbol );
                m_items[i].Original.ID.LyricHandle.L0.Phrase = proxy.Phrase;
                m_items[i].Original.ID.Note = proxy.Note;
                m_items[i].Original.ID.PMBendDepth = proxy.BendDepth;
                m_items[i].Original.ID.PMBendLength = proxy.BendLength;
                m_items[i].Original.ID.PMbPortamentoUse = proxy.GetPortamentoUsage();
                m_items[i].Original.ID.VibratoDelay = proxy.GetVibratoDelay();
                m_items[i].Original.UstEvent.PreUtterance = proxy.PreUtterance;
                m_items[i].Original.UstEvent.VoiceOverlap = proxy.Overlap;
                m_items[i].Original.UstEvent.Moduration = proxy.Moduration;
            }
            if ( CommandExecuteRequired != null ) {
                CadenciiCommand run = new CadenciiCommand( VsqCommand.generateCommandEventReplaceRange( m_track, items ) );
                CommandExecuteRequired( run );
            }
        }*/

        public Keys FormCloseShortcutKey {
            get {
                return menuClose.ShortcutKeys;
            }
            set {
                menuClose.ShortcutKeys = value;
            }
        }

        private void menuClose_Click( object sender, EventArgs e ) {
            this.Close();
        }
    }

}
